# vim: set sw=4 ts=4 et:
# Copyright (c) 2010-2012 Pascal Bleser <pascal.bleser@opensuse.org>
# Copyright (c) 2005-2010 oc2pus
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/


Name:           mixxx-1-11
Summary:        Open Source DJ tool
%define rev     20130824212813
Version:        1.11.999+1.12.0+alpha+trunk+%{rev}
Release:        9.88
License:        GPL-2.0+
Group:          Productivity/Multimedia/Sound/Players
URL:            http://mixxx.sourceforge.net/
ExclusiveArch:  %ix86 x86_64
Source0:        mixxx-%{rev}.tar.bz2
Source1:        mixxx.desktop
Source2:        libmp4v2-20170208.tar.bz2
%if %rev > 20130824212813
Patch1:         mixxx-disable_qt_rpath-new.patch
Patch2:         mixxx-fix_modifying_const_qstring.patch
%else
Patch3:         mixxx-disable_qt_rpath.patch
%endif
Patch4:         mixxx-remove_build_timestamps.patch
Patch5:         mixxx-add_set_to_xx.patch
Patch6:         mixxx.narrow-conversion.patch
Source99:       %{name}-rpmlintrc
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  unzip
BuildRequires:  alsa-devel
BuildRequires:  audiofile-devel audiofile
BuildRequires:  fdupes
BuildRequires:  freeglut-devel
BuildRequires:  glib2-devel
BuildRequires:  ladspa
BuildRequires:  libdjconsole-devel
BuildRequires:  portmidi-devel
BuildRequires:  libtag-devel
BuildRequires:  flac-devel
BuildRequires:  automake autoconf libtool
BuildRequires:  wavpack-devel
BuildRequires:  libgpod-devel
BuildRequires:  libid3tag-devel
BuildRequires:  libjack-devel >= 0.109
BuildRequires:  libmp3lame-devel
BuildRequires:  libmusicbrainz-devel
BuildRequires:  librubberband-devel
BuildRequires:  libsamplerate-devel
BuildRequires:  libshout-devel
BuildRequires:  libsndfile-devel
BuildRequires:  libusb-devel
BuildRequires:  libusb-1_0-devel
BuildRequires:  libvorbis-devel
BuildRequires:  libopus-devel
BuildRequires:  opusfile-devel >= 0.2
BuildRequires:  mad-devel
BuildRequires:  libchromaprint-devel
BuildRequires:  pkgconfig
BuildRequires:  portaudio-devel
BuildRequires:  python-devel
BuildRequires:  libqt4-devel
BuildRequires:  libQtWebKit-devel
BuildRequires:  scons
BuildRequires:  soundtouch-devel >= 1.3
BuildRequires:  update-desktop-files
BuildRequires:  zlib-devel
BuildRequires:  util-linux
BuildRequires:  google-perftools-devel
# needed for OBS to decide:
BuildRequires:  google-perftools
BuildRequires:  protobuf-devel
# this one shouldn't be needed, put apparently there is a missing dependency
# in protobuf-devel towards libprotobuf-lite*:
# BuildRequires:  libprotobuf-lite6
BuildRequires:  vamp-plugin-sdk-devel
Obsoletes:      %{name}-skin-hercules
Obsoletes:      %{name}-skin-outlineClose
Obsoletes:      %{name}-skin-outline
Obsoletes:      %{name}-skin-outlineMini
Obsoletes:      %{name}-skin-outlineNetbook
Obsoletes:      %{name}-skin-nCut
Obsoletes:      %{name}-skin-Collusion
Obsoletes:      %{name}-skin-traditional
Provides:       mixxx = %{version}-%{release}
Conflicts:      mixxx-unstable
Conflicts:      mixxx
Recommends:     libmp3lame0
Requires:       vamp-qm-plugins
BuildRequires:  libqt4-sql-sqlite
Requires:       libqt4-sql-sqlite

%description
Mixxx is designed for DJ'ing for both professional and
semi-professional users.
Mixxx was started in early 2001 as one of the first digital
DJ systems.

Today Mixxx includes many features common to digital DJ solutions,
but also some very unique features: It is free, and runs on all
major desktop operating systems.

Furthermore Mixxx has a number of key features to help the DJ in
the live mix: Beat estimation, parallel visual displays, and
support for many DJ input controllers.

Mixxx is software for DJ'ing. You can use wave based audio files,
Ogg Vorbis and MP3 files as audio input. Mixxx can be controlled
through the GUI and with external controllers including MIDI
devices, joysticks and more.

%prep
%setup -q -n mixxx -a 2
%if %rev > 20130824212813
%patch1
%patch2
%else
%patch3
%endif
%patch4
%patch5
%patch6 -p1

pushd libmp4v2
autoreconf -fiv .
CFLAGS="%{optflags}" \
CPPFLAGS="%{optflags}" \
CXXFLAGS="%{optflags}" \
./configure \
    --prefix="%{_libdir}/mixxx/libmp4v2" \
    --libdir="%{_libdir}/mixxx/libmp4v2" \
    --includedir="%{_libdir}/mixxx/libmp4v2/include" \
    --mandir="%{_libdir}/mixxx/libmp4v2/man" \
    --bindir="%{_libdir}/mixxx/libmp4v2/bin"
popd

%build
# regenerate protobuf code with the current version
# of protobuf (not doing so fails the build):
pushd src/proto
protoc beats.proto --cpp_out=.
popd #src/proto

pushd libmp4v2
make %{?_smp_mflags}
%makeinstall
popd

CPPFLAGS="%{optflags} -I%{buildroot}%{_libdir}/mixxx/libmp4v2/include" \
CFLAGS="%{optflags} -I%{buildroot}%{_libdir}/mixxx/libmp4v2/include" \
CXXFLAGS="%{optflags} -I%{buildroot}%{_libdir}/mixxx/libmp4v2/include" \
LDFLAGS="%{optflags} -L%{buildroot}%{_libdir}/mixxx/libmp4v2" \
scons %{?_smp_mflags} \
    prefix="%{_prefix}" \
    optimize=9 \
    djconsole=1 \
    djconsole_legacy=0 \
    hifieq=1 \
    experimentalrecord=1 \
    cmetrics=0 \
    ladspa=0 \
    vinylcontrol=1 \
    ffmpeg=0 \
    opus=1 \
    shoutcast=1 \
    ipod=0 \
    script=1 \
    midiscript=1 \
    tonal=1 \
    m4a=0 \
    faad=0 \
    mad=1 \
    hss1394=0 \
    wv=1 \
    asmlib=0 \
    portmidi=1 \
    shoutcast=1 \
    modplug=0 \
    qdebug=0 \
    perftools=0

%install
%__install -dm 755 %{buildroot}%{_bindir}

CPPFLAGS="%{optflags} -I%{buildroot}%{_libdir}/mixxx/libmp4v2/include" \
CFLAGS="%{optflags} -I%{buildroot}%{_libdir}/mixxx/libmp4v2/include" \
CXXFLAGS="%{optflags} -I%{buildroot}%{_libdir}/mixxx/libmp4v2/include" \
LDFLAGS="%{optflags} -L%{buildroot}%{_libdir}/mixxx/libmp4v2" \
scons \
    prefix="%{_prefix}" \
    optimize=9 \
    djconsole=1 \
    djconsole_legacy=0 \
    hifieq=1 \
    experimentalrecord=1 \
    cmetrics=0 \
    ladspa=0 \
    vinylcontrol=1 \
    ffmpeg=0 \
    opus=1 \
    shoutcast=1 \
    ipod=0 \
    script=0 \
    midiscript=1 \
    tonal=1 \
    m4a=0 \
    faad=0 \
    mad=1 \
    hss1394=0 \
    wv=1 \
    asmlib=0 \
    portmidi=1 \
    shoutcast=1 \
    modplug=0 \
    qdebug=0 \
    perftools=0 \
    install_root="%{buildroot}%{_prefix}" \
    install

%__rm -rf "%{buildroot}%{_libdir}/mixxx/libmp4v2"/{bin,include,man,libmp4v2.{a,la,so}}

%__rm -rf "%{buildroot}%{_datadir}/doc/mixxx"

# remove .orig files, not permitted
find "%{buildroot}%{_datadir}/mixxx/skins/" -type f -name '*.orig' -delete

# fix perms
find "%{buildroot}%{_datadir}/mixxx/" -type f -executable \( -name '*.xml' -o -name '*.js' -o -name '*.txt' \) \
-exec %__chmod 0644 {} \;

%__install -D -m0644 res/images/mixxx-icon.png "%{buildroot}%{_datadir}/pixmaps/mixxx-icon.png"
%__install -D -m0644 "%{SOURCE1}" "%{buildroot}%{_datadir}/applications/mixxx.desktop"
%suse_update_desktop_file -r mixxx AudioVideo Player Jukebox

L="$PWD/%{name}.lang"
echo -n > "$L"
pushd "%{buildroot}%{_datadir}/mixxx/translations"
/bin/ls -1 mixxx_*.qm | while read f; do
    [ -e "$f" ] || continue
    l="${f#mixxx_}"
    l="${l%.qm}"
    echo "%lang($l) %{_datadir}/mixxx/translations/$f" >> "$L"
done
popd

%fdupes -s "%{buildroot}%{_datadir}/mixxx/skins" &>/dev/null

%clean
%{?buildroot:%__rm -rf "%{buildroot}"}

%files -f %{name}.lang
%defattr(-,root,root)
%doc COPYING LICENSE Mixxx-Manual.pdf README*
%{_bindir}/mixxx
%dir %{_prefix}/lib/mixxx
%dir %{_prefix}/lib/mixxx/plugins
%dir %{_prefix}/lib/mixxx/plugins/soundsource
%{_prefix}/lib/mixxx/plugins/soundsource/libsoundsourcewv.so
%dir %{_prefix}/lib/mixxx/plugins/vamp
%{_prefix}/lib/mixxx/plugins/vamp/libmixxxminimal.so
%dir %{_datadir}/mixxx
%{_datadir}/mixxx/schema.xml
%{_datadir}/mixxx/controllers
%{_datadir}/mixxx/keyboard
%{_datadir}/mixxx/skins
%dir %{_datadir}/mixxx/translations
%{_datadir}/applications/mixxx.desktop
%{_datadir}/pixmaps/mixxx-icon.png
%dir %{_libdir}/mixxx
%dir %{_libdir}/mixxx/libmp4v2
%{_libdir}/mixxx/libmp4v2/libmp4v2.so.2
%{_libdir}/mixxx/libmp4v2/libmp4v2.so.2.*

%changelog
* Sat Apr 14 2018 pascal.bleser@opensuse.org
- add included libmp4v2 and build against it
- re-enable MP4 and FAAD
* Sun Mar 12 2017 olaf@aepfle.de
- Disable mp4 and faad because libmp4v2 was dropped
* Thu Feb  2 2017 pascal.bleser@opensuse.org
- initial package, fully functional build of 1.11/1.12
